﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_add_delegates
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // A delegate that represents a method that adds something to the ListBox.
        private delegate void AddToListDelegate();

        // Specific methods that match the delegate.
        private void MethodA()
        {
            lstResults.Items.Add("    This is MethodA");
        }
        private void MethodB()
        {
            lstResults.Items.Add("    This is MethodB");
        }

        // Define and use three delegates.
        private void Form1_Load(object sender, EventArgs e)
        {
            // Define delegate variables.
            AddToListDelegate A = MethodA;
            AddToListDelegate B = MethodB;
            AddToListDelegate C = A + B;

            // Use the delegates.
            lstResults.Items.Add("Calling A:");
            A();
            lstResults.Items.Add("Calling B:");
            B();
            lstResults.Items.Add("Calling C:");
            C();
            lstResults.Items.Add("Calling C - A:");
            (C - A)();
            lstResults.Items.Add("Calling C -= A:");
            C -= A;
            C();
        }
    }
}
